<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>NettyServerCnxnFactory.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">NettyServerCnxnFactory.java</span></div><h1>NettyServerCnxnFactory.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import static org.jboss.netty.buffer.ChannelBuffers.dynamicBuffer;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.Executors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.jboss.netty.bootstrap.ServerBootstrap;
import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.buffer.ChannelBuffers;
import org.jboss.netty.channel.Channel;
import org.jboss.netty.channel.ChannelHandler.Sharable;
import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.channel.ChannelStateEvent;
import org.jboss.netty.channel.ExceptionEvent;
import org.jboss.netty.channel.MessageEvent;
import org.jboss.netty.channel.SimpleChannelHandler;
import org.jboss.netty.channel.WriteCompletionEvent;
import org.jboss.netty.channel.group.ChannelGroup;
import org.jboss.netty.channel.group.DefaultChannelGroup;
import org.jboss.netty.channel.socket.nio.NioServerSocketChannelFactory;

public class NettyServerCnxnFactory extends ServerCnxnFactory {
<span class="fc" id="L49">    Logger LOG = LoggerFactory.getLogger(NettyServerCnxnFactory.class);</span>

    ServerBootstrap bootstrap;
    Channel parentChannel;
<span class="fc" id="L53">    ChannelGroup allChannels = new DefaultChannelGroup(&quot;zkServerCnxns&quot;);</span>
<span class="fc" id="L54">    HashMap&lt;InetAddress, Set&lt;NettyServerCnxn&gt;&gt; ipMap =</span>
        new HashMap&lt;InetAddress, Set&lt;NettyServerCnxn&gt;&gt;( );
    InetSocketAddress localAddress;
<span class="fc" id="L57">    int maxClientCnxns = 60;</span>
    
    /**
     * This is an inner class since we need to extend SimpleChannelHandler, but
     * NettyServerCnxnFactory already extends ServerCnxnFactory. By making it inner
     * this class gets access to the member variables and methods.
     */
    @Sharable
<span class="fc" id="L65">    class CnxnChannelHandler extends SimpleChannelHandler {</span>

        @Override
        public void channelClosed(ChannelHandlerContext ctx, ChannelStateEvent e)
            throws Exception
        {
<span class="pc bpc" id="L71" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L72">                LOG.trace(&quot;Channel closed &quot; + e);</span>
            }
<span class="fc" id="L74">            allChannels.remove(ctx.getChannel());</span>
<span class="fc" id="L75">        }</span>

        @Override
        public void channelConnected(ChannelHandlerContext ctx,
                ChannelStateEvent e) throws Exception
        {
<span class="pc bpc" id="L81" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L82">                LOG.trace(&quot;Channel connected &quot; + e);</span>
            }
<span class="fc" id="L84">            allChannels.add(ctx.getChannel());</span>
<span class="fc" id="L85">            NettyServerCnxn cnxn = new NettyServerCnxn(ctx.getChannel(),</span>
                    zkServer, NettyServerCnxnFactory.this);
<span class="fc" id="L87">            ctx.setAttachment(cnxn);</span>
<span class="fc" id="L88">            addCnxn(cnxn);</span>
<span class="fc" id="L89">        }</span>

        @Override
        public void channelDisconnected(ChannelHandlerContext ctx,
                ChannelStateEvent e) throws Exception
        {
<span class="pc bpc" id="L95" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L96">                LOG.trace(&quot;Channel disconnected &quot; + e);</span>
            }
<span class="fc" id="L98">            NettyServerCnxn cnxn = (NettyServerCnxn) ctx.getAttachment();</span>
<span class="pc bpc" id="L99" title="1 of 2 branches missed.">            if (cnxn != null) {</span>
<span class="pc bpc" id="L100" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L101">                    LOG.trace(&quot;Channel disconnect caused close &quot; + e);</span>
                }
<span class="fc" id="L103">                cnxn.close();</span>
            }
<span class="fc" id="L105">        }</span>

        @Override
        public void exceptionCaught(ChannelHandlerContext ctx, ExceptionEvent e)
            throws Exception
        {
<span class="fc" id="L111">            LOG.warn(&quot;Exception caught &quot; + e, e.getCause());</span>
<span class="fc" id="L112">            NettyServerCnxn cnxn = (NettyServerCnxn) ctx.getAttachment();</span>
<span class="pc bpc" id="L113" title="1 of 2 branches missed.">            if (cnxn != null) {</span>
<span class="pc bpc" id="L114" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L115">                    LOG.debug(&quot;Closing &quot; + cnxn);</span>
<span class="nc" id="L116">                    cnxn.close();</span>
                }
            }
<span class="fc" id="L119">        }</span>

        @Override
        public void messageReceived(ChannelHandlerContext ctx, MessageEvent e)
            throws Exception
        {
<span class="pc bpc" id="L125" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L126">                LOG.trace(&quot;message received called &quot; + e.getMessage());</span>
            }
            try {
<span class="pc bpc" id="L129" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L130">                    LOG.debug(&quot;New message &quot; + e.toString()</span>
<span class="nc" id="L131">                            + &quot; from &quot; + ctx.getChannel());</span>
                }
<span class="fc" id="L133">                NettyServerCnxn cnxn = (NettyServerCnxn)ctx.getAttachment();</span>
<span class="fc" id="L134">                synchronized(cnxn) {</span>
<span class="fc" id="L135">                    processMessage(e, cnxn);</span>
<span class="pc" id="L136">                }</span>
<span class="nc" id="L137">            } catch(Exception ex) {</span>
<span class="nc" id="L138">                LOG.error(&quot;Unexpected exception in receive&quot;, ex);</span>
<span class="nc" id="L139">                throw ex;</span>
<span class="fc" id="L140">            }</span>
<span class="fc" id="L141">        }</span>

        private void processMessage(MessageEvent e, NettyServerCnxn cnxn) {
<span class="pc bpc" id="L144" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L145">                LOG.debug(Long.toHexString(cnxn.sessionId) + &quot; queuedBuffer: &quot;</span>
                        + cnxn.queuedBuffer);
            }

<span class="fc bfc" id="L149" title="All 2 branches covered.">            if (e instanceof NettyServerCnxn.ResumeMessageEvent) {</span>
<span class="fc" id="L150">                LOG.debug(&quot;Received ResumeMessageEvent&quot;);</span>
<span class="fc bfc" id="L151" title="All 2 branches covered.">                if (cnxn.queuedBuffer != null) {</span>
<span class="pc bpc" id="L152" title="1 of 2 branches missed.">                    if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L153">                        LOG.trace(&quot;processing queue &quot;</span>
<span class="nc" id="L154">                                + Long.toHexString(cnxn.sessionId)</span>
                                + &quot; queuedBuffer 0x&quot;
<span class="nc" id="L156">                                + ChannelBuffers.hexDump(cnxn.queuedBuffer));</span>
                    }
<span class="fc" id="L158">                    cnxn.receiveMessage(cnxn.queuedBuffer);</span>
<span class="fc bfc" id="L159" title="All 2 branches covered.">                    if (!cnxn.queuedBuffer.readable()) {</span>
<span class="fc" id="L160">                        LOG.debug(&quot;Processed queue - no bytes remaining&quot;);</span>
<span class="fc" id="L161">                        cnxn.queuedBuffer = null;</span>
                    } else {
<span class="fc" id="L163">                        LOG.debug(&quot;Processed queue - bytes remaining&quot;);</span>
                    }
                } else {
<span class="fc" id="L166">                    LOG.debug(&quot;queue empty&quot;);</span>
                }
<span class="fc" id="L168">                cnxn.channel.setReadable(true);</span>
            } else {
<span class="fc" id="L170">                ChannelBuffer buf = (ChannelBuffer)e.getMessage();</span>
<span class="pc bpc" id="L171" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L172">                    LOG.trace(Long.toHexString(cnxn.sessionId)</span>
                            + &quot; buf 0x&quot;
<span class="nc" id="L174">                            + ChannelBuffers.hexDump(buf));</span>
                }
                
<span class="fc bfc" id="L177" title="All 2 branches covered.">                if (cnxn.throttled) {</span>
<span class="fc" id="L178">                    LOG.debug(&quot;Received message while throttled&quot;);</span>
                    // we are throttled, so we need to queue
<span class="fc bfc" id="L180" title="All 2 branches covered.">                    if (cnxn.queuedBuffer == null) {</span>
<span class="fc" id="L181">                        LOG.debug(&quot;allocating queue&quot;);</span>
<span class="fc" id="L182">                        cnxn.queuedBuffer = dynamicBuffer(buf.readableBytes());</span>
                    }
<span class="fc" id="L184">                    cnxn.queuedBuffer.writeBytes(buf);</span>
<span class="pc bpc" id="L185" title="1 of 2 branches missed.">                    if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L186">                        LOG.trace(Long.toHexString(cnxn.sessionId)</span>
                                + &quot; queuedBuffer 0x&quot;
<span class="nc" id="L188">                                + ChannelBuffers.hexDump(cnxn.queuedBuffer));</span>
                    }
                } else {
<span class="fc" id="L191">                    LOG.debug(&quot;not throttled&quot;);</span>
<span class="fc bfc" id="L192" title="All 2 branches covered.">                    if (cnxn.queuedBuffer != null) {</span>
<span class="pc bpc" id="L193" title="1 of 2 branches missed.">                        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L194">                            LOG.trace(Long.toHexString(cnxn.sessionId)</span>
                                    + &quot; queuedBuffer 0x&quot;
<span class="nc" id="L196">                                    + ChannelBuffers.hexDump(cnxn.queuedBuffer));</span>
                        }
<span class="fc" id="L198">                        cnxn.queuedBuffer.writeBytes(buf);</span>
<span class="pc bpc" id="L199" title="1 of 2 branches missed.">                        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L200">                            LOG.trace(Long.toHexString(cnxn.sessionId)</span>
                                    + &quot; queuedBuffer 0x&quot;
<span class="nc" id="L202">                                    + ChannelBuffers.hexDump(cnxn.queuedBuffer));</span>
                        }

<span class="fc" id="L205">                        cnxn.receiveMessage(cnxn.queuedBuffer);</span>
<span class="pc bpc" id="L206" title="1 of 2 branches missed.">                        if (!cnxn.queuedBuffer.readable()) {</span>
<span class="nc" id="L207">                            LOG.debug(&quot;Processed queue - no bytes remaining&quot;);</span>
<span class="nc" id="L208">                            cnxn.queuedBuffer = null;</span>
                        } else {
<span class="fc" id="L210">                            LOG.debug(&quot;Processed queue - bytes remaining&quot;);</span>
                        }
                    } else {
<span class="fc" id="L213">                        cnxn.receiveMessage(buf);</span>
<span class="fc bfc" id="L214" title="All 2 branches covered.">                        if (buf.readable()) {</span>
<span class="pc bpc" id="L215" title="1 of 2 branches missed.">                            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L216">                                LOG.trace(&quot;Before copy &quot; + buf);</span>
                            }
<span class="fc" id="L218">                            cnxn.queuedBuffer = dynamicBuffer(buf.readableBytes()); </span>
<span class="fc" id="L219">                            cnxn.queuedBuffer.writeBytes(buf);</span>
<span class="pc bpc" id="L220" title="1 of 2 branches missed.">                            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L221">                                LOG.trace(&quot;Copy is &quot; + cnxn.queuedBuffer);</span>
<span class="nc" id="L222">                                LOG.trace(Long.toHexString(cnxn.sessionId)</span>
                                        + &quot; queuedBuffer 0x&quot;
<span class="nc" id="L224">                                        + ChannelBuffers.hexDump(cnxn.queuedBuffer));</span>
                            }
                        }
                    }
                }
            }
<span class="fc" id="L230">        }</span>

        @Override
        public void writeComplete(ChannelHandlerContext ctx,
                WriteCompletionEvent e) throws Exception
        {
<span class="pc bpc" id="L236" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L237">                LOG.trace(&quot;write complete &quot; + e);</span>
            }
<span class="fc" id="L239">        }</span>
        
    }
    
<span class="fc" id="L243">    CnxnChannelHandler channelHandler = new CnxnChannelHandler();</span>
    
<span class="fc" id="L245">    NettyServerCnxnFactory() {</span>
<span class="fc" id="L246">        bootstrap = new ServerBootstrap(</span>
                new NioServerSocketChannelFactory(
<span class="fc" id="L248">                        Executors.newCachedThreadPool(),</span>
<span class="fc" id="L249">                        Executors.newCachedThreadPool()));</span>
        // parent channel
<span class="fc" id="L251">        bootstrap.setOption(&quot;reuseAddress&quot;, true);</span>
        // child channels
<span class="fc" id="L253">        bootstrap.setOption(&quot;child.tcpNoDelay&quot;, true);</span>
        /* set socket linger to off, so that socket close does not block */
<span class="fc" id="L255">        bootstrap.setOption(&quot;child.soLinger&quot;, -1);</span>

<span class="fc" id="L257">        bootstrap.getPipeline().addLast(&quot;servercnxnfactory&quot;, channelHandler);</span>
<span class="fc" id="L258">    }</span>
    
    @Override
    public void closeAll() {
<span class="pc bpc" id="L262" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L263">            LOG.debug(&quot;closeAll()&quot;);</span>
        }

<span class="fc" id="L266">        NettyServerCnxn[] allCnxns = null;</span>
<span class="fc" id="L267">        synchronized (cnxns) {</span>
<span class="fc" id="L268">            allCnxns = cnxns.toArray(new NettyServerCnxn[cnxns.size()]);</span>
<span class="pc" id="L269">        }</span>
        // got to clear all the connections that we have in the selector
<span class="fc bfc" id="L271" title="All 2 branches covered.">        for (NettyServerCnxn cnxn : allCnxns) {</span>
            try {
<span class="fc" id="L273">                cnxn.close();</span>
<span class="nc" id="L274">            } catch (Exception e) {</span>
<span class="nc" id="L275">                LOG.warn(&quot;Ignoring exception closing cnxn sessionid 0x&quot;</span>
<span class="nc" id="L276">                                + Long.toHexString(cnxn.getSessionId()), e);</span>
<span class="fc" id="L277">            }</span>
        }
<span class="pc bpc" id="L279" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L280">            LOG.debug(&quot;allChannels size:&quot; + allChannels.size() + &quot; cnxns size:&quot;</span>
                    + allCnxns.length);
        }
<span class="fc" id="L283">    }</span>

    @Override
    public void closeSession(long sessionId) {
<span class="pc bpc" id="L287" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L288">            LOG.debug(&quot;closeSession sessionid:0x&quot; + sessionId);</span>
        }
<span class="fc" id="L290">        NettyServerCnxn[] allCnxns = null;</span>
<span class="fc" id="L291">        synchronized (cnxns) {</span>
<span class="fc" id="L292">            allCnxns = cnxns.toArray(new NettyServerCnxn[cnxns.size()]);</span>
<span class="pc" id="L293">        }</span>
<span class="fc bfc" id="L294" title="All 2 branches covered.">        for (NettyServerCnxn cnxn : allCnxns) {</span>
<span class="fc bfc" id="L295" title="All 2 branches covered.">            if (cnxn.getSessionId() == sessionId) {</span>
                try {
<span class="fc" id="L297">                    cnxn.close();</span>
<span class="nc" id="L298">                } catch (Exception e) {</span>
<span class="nc" id="L299">                    LOG.warn(&quot;exception during session close&quot;, e);</span>
<span class="fc" id="L300">                }</span>
<span class="nc" id="L301">                break;</span>
            }
        }
<span class="fc" id="L304">    }</span>

    @Override
    public void configure(InetSocketAddress addr, int maxClientCnxns)
            throws IOException
    {
<span class="fc" id="L310">        configureSaslLogin();</span>
<span class="fc" id="L311">        localAddress = addr;</span>
<span class="fc" id="L312">        this.maxClientCnxns = maxClientCnxns;</span>
<span class="fc" id="L313">    }</span>

    /** {@inheritDoc} */
    public int getMaxClientCnxnsPerHost() {
<span class="fc" id="L317">        return maxClientCnxns;</span>
    }

    /** {@inheritDoc} */
    public void setMaxClientCnxnsPerHost(int max) {
<span class="nc" id="L322">        maxClientCnxns = max;</span>
<span class="nc" id="L323">    }</span>

    @Override
    public int getLocalPort() {
<span class="fc" id="L327">        return localAddress.getPort();</span>
    }

    boolean killed;
    @Override
    public void join() throws InterruptedException {
<span class="nc" id="L333">        synchronized(this) {</span>
<span class="nc bnc" id="L334" title="All 2 branches missed.">            while(!killed) {</span>
<span class="nc" id="L335">                wait();</span>
            }
<span class="nc" id="L337">        }</span>
<span class="nc" id="L338">    }</span>

    @Override
    public void shutdown() {
<span class="fc" id="L342">        LOG.info(&quot;shutdown called &quot; + localAddress);</span>
<span class="pc bpc" id="L343" title="1 of 2 branches missed.">        if (login != null) {</span>
<span class="nc" id="L344">            login.shutdown();</span>
        }
        // null if factory never started
<span class="pc bpc" id="L347" title="1 of 2 branches missed.">        if (parentChannel != null) {</span>
<span class="fc" id="L348">            parentChannel.close().awaitUninterruptibly();</span>
<span class="fc" id="L349">            closeAll();</span>
<span class="fc" id="L350">            allChannels.close().awaitUninterruptibly();</span>
<span class="fc" id="L351">            bootstrap.releaseExternalResources();</span>
        }

<span class="fc bfc" id="L354" title="All 2 branches covered.">        if (zkServer != null) {</span>
<span class="fc" id="L355">            zkServer.shutdown();</span>
        }
<span class="fc" id="L357">        synchronized(this) {</span>
<span class="fc" id="L358">            killed = true;</span>
<span class="fc" id="L359">            notifyAll();</span>
<span class="pc" id="L360">        }</span>
<span class="fc" id="L361">    }</span>
    
    @Override
    public void start() {
<span class="fc" id="L365">        LOG.info(&quot;binding to port &quot; + localAddress);</span>
<span class="fc" id="L366">        parentChannel = bootstrap.bind(localAddress);</span>
<span class="fc" id="L367">    }</span>

    @Override
    public void startup(ZooKeeperServer zks) throws IOException,
            InterruptedException {
<span class="fc" id="L372">        start();</span>
<span class="fc" id="L373">        setZooKeeperServer(zks);</span>
<span class="fc" id="L374">        zks.startdata();</span>
<span class="fc" id="L375">        zks.startup();</span>
<span class="fc" id="L376">    }</span>

    @Override
    public Iterable&lt;ServerCnxn&gt; getConnections() {
<span class="fc" id="L380">        return cnxns;</span>
    }

    @Override
    public InetSocketAddress getLocalAddress() {
<span class="fc" id="L385">        return localAddress;</span>
    }

    private void addCnxn(NettyServerCnxn cnxn) {
<span class="fc" id="L389">        synchronized (cnxns) {</span>
<span class="fc" id="L390">            cnxns.add(cnxn);</span>
<span class="fc" id="L391">            synchronized (ipMap){</span>
<span class="fc" id="L392">                InetAddress addr =</span>
<span class="fc" id="L393">                    ((InetSocketAddress)cnxn.channel.getRemoteAddress())</span>
<span class="fc" id="L394">                        .getAddress();</span>
<span class="fc" id="L395">                Set&lt;NettyServerCnxn&gt; s = ipMap.get(addr);</span>
<span class="fc bfc" id="L396" title="All 2 branches covered.">                if (s == null) {</span>
<span class="fc" id="L397">                    s = new HashSet&lt;NettyServerCnxn&gt;();</span>
                }
<span class="fc" id="L399">                s.add(cnxn);</span>
<span class="fc" id="L400">                ipMap.put(addr,s);</span>
<span class="pc" id="L401">            }</span>
<span class="pc" id="L402">        }</span>
<span class="fc" id="L403">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>